/*
 * radiotrim -
 * pieced together by Jostein Kjønigsen for his own purposes and those only.
 * this is meant to work, not to be pretty or idiomatic c.
 */

#include <stdlib.h>
#include <stdio.h>

char* buffer;
const char* source_name = "raw.img";
char* output_name;

unsigned long fileLen;

FILE *source;
FILE *adb;
FILE *test;

int result;

/* because windows and linux just cant agree about everything */
#ifdef _WIN32
#define popen(process,mode) _popen(process,mode)
#define pclose(handle) _pclose(handle)
#endif

// ref
// http://forum.xda-developers.com/showpost.php?p=22741212&postcount=42
const unsigned int nameOffset = 0x009fefc0;
const unsigned int radioSize = 0x00c00100;

int main( int argc, char *argv[] )
{
	printf("\nSamsung Galaxy Nexus I9250 radio-image grabber.\n");

	if (argc != 2)
	{
		printf("Written by Jostein Kjonigsen for his own use only.\n\n");
		printf("This tool depends on adb to be in your path.\n");
		printf("This tool requires your phone to be rooted.\n");
		printf("This tool comes with NO warranties provided.\n\n");
		printf("usage: %s output.img\n", argv[0] );
		exit(1);
	}

	printf("Grabbing started...\n");

	// gradually root up, because not all phones comes with adb running as root
	adb = popen ("adb shell", "w"); 
	fprintf (adb, "su\n"); 

	// create image
	// grab only first 12583168/0x00C00100 bytes. according to following forum post:
	// http://forum.xda-developers.com/showpost.php?p=22741212&postcount=42
	fprintf (adb, "dd bs=256 count=49153 if=/dev/block/platform/omap/omap_hsmmc.0/by-name/radio of=/sdcard/raw.img\n"); 

	// exit root and adb shell and give control back to process.
	fprintf (adb, "exit\n"); 
	fprintf (adb, "exit\n"); 
	result = pclose (adb); 

	// pull generated image
	sysexec("adb pull /sdcard/raw.img .");

	//Open file
	//source_name = "raw.img";
	source = fopen(source_name, "rb");
	if (!source)
	{
		fprintf(stderr, "Unable to open file %s\n", source_name);
		exit(1);
	}

	fprintf(stdout, "Radio grabbed successfully.\n");

	//Get file length
	fseek(source, 0, SEEK_END);
	fileLen=ftell(source);
	fseek(source, 0, SEEK_SET);

	if (fileLen < radioSize)
	{
		fprintf(stderr, "Possibly incomplete source-image. This should never happen. Aborting.");
		fclose(source);
		exit(1);
	}

	//Allocate memory
	buffer=(char *)malloc(radioSize);
	if (!buffer)
	{
		fprintf(stderr, "Memory error!");
		fclose(source);
		exit(1);
	}

	//Read file contents into buffer
	fread(buffer, radioSize, 1, source);
	fclose(source);

	// baseband-name location.
	if (fileLen > nameOffset)
	{
		fprintf(stdout, "Detected baseband name: %s\n", (buffer+nameOffset));
	}

	// image is ready. rename.
	output_name = argv[1];

	// check if file already exists, and in that case just delete it.
	test = fopen(output_name,"r");
	if (test != NULL)
	{
		fclose(test);
		remove(output_name);
	}

	result = rename("raw.img", output_name);
	if (result == -1)
	{
		fprintf(stderr, "Error renaming image to %s", output_name);
		free(buffer);
		exit(1);
	}

	// attempt to clean up
	free(buffer);
	sysexec("adb shell rm /sdcard/raw.img");

	// goodbye
	return 0;
}

int ret;
int sysexec(char *command)
{
	ret = system(command);

	if (ret != 0)
	{
		fprintf(stderr, "Error executing command: %s\n", command);
		exit(1);
	}

	return 0;
}
